﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using GrapeCity.ActiveReports;
using GrapeCity.ActiveReports.Viewer.Wpf;
using System.Threading;
using System.Windows.Threading;

namespace WpfActiveReports
{
    /// <summary>
    /// MainWindow.xaml 的交互逻辑
    /// </summary>
    public partial class MainWindow : Window
    {
//        private delegate void DoTask();

        public MainWindow()
        {
            InitializeComponent();
//             Thread t = new Thread(new ThreadStart(Start));
//             t.Start();
        }

//         private void Start()
//         {
//             System.Windows.Application.Current.Dispatcher.Invoke(DispatcherPriority.Background, new DoTask(DoMyTask));
//         }
//         private void DoMyTask()
//         {
//             //在此执行你的代码
// 
//         }

        public void ShowWindow()
        {
            this.Show();
        }

        public void DirectShowWindow()
        {
                string strPath = GetTemplatePath();
                string strName = GetName();
                CreatePageReport(strPath, strName, viewer1, string.Empty);
                this.Show();
        }

        public string GetTemplatePath()
        {
            //return "D:\\TestWpf\\Wpf_app\\Wpf_app\\Template\\";
            return GetAppPath();
        }

        public string GetName()
        {
            return "PageReport1.rdlx";
        }

        private string GetAppPath()
        {
            return System.AppDomain.CurrentDomain.BaseDirectory;
        }

        public void CreatePageReport(string strPath, string name, Viewer viewer, string theme)
        {
            string strNeededPath = strPath + string.Format(@"\{0}", name);
            PageReport report1 = new PageReport(new System.IO.FileInfo(strNeededPath));
            if (!string.IsNullOrEmpty(theme))
            {
                report1.Report.Themes.Clear();
                report1.Report.Themes.Add(theme);
            }
            GrapeCity.ActiveReports.Document.PageDocument document1 = new GrapeCity.ActiveReports.Document.PageDocument(report1);
            document1.LocateDataSource += new LocateDataSourceEventHandler(pageDocument_LocateDataSource);
//             if (this.Dispatcher.CheckAccess())
//             {
//                 this.Dispatcher.Invoke(new Action(() => { viewer.LoadDocument(document1); }));
//             }
            viewer.LoadDocument(document1);
        }


        public void pageDocument_LocateDataSource(object sender, LocateDataSourceEventArgs args)
        {
            //args.Data = m_Report.GetDataTable();
            String str = "";
            str.ToLower();
        }
    }
}
